"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var node_path_1 = require("node:path");
var utils_1 = require("../../utils");
var cyclomatic_1 = require("./cyclomatic");
var halstead_1 = require("./halstead");
var sloc_1 = require("./sloc");
var internal = { debug: (0, utils_1.buildDebugger)("complexity") };
exports["default"] = {
    compute: function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return (0, utils_1.withDuration)(compute, args, internal.debug);
    }
};
function compute(paths, options) {
    return __awaiter(this, void 0, void 0, function () {
        var entries;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    internal.debug("".concat(paths.length, " files to compute complexity on"));
                    return [4 /*yield*/, Promise.all(paths.map(function (path) { return __awaiter(_this, void 0, void 0, function () {
                            var complexity;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, computeComplexity(path, options)];
                                    case 1:
                                        complexity = _a.sent();
                                        return [2 /*return*/, { path: path, complexity: complexity }];
                                }
                            });
                        }); }))];
                case 1:
                    entries = _a.sent();
                    return [2 /*return*/, entries.reduce(function (map, entry) {
                            map.set(entry.path, entry.complexity);
                            return map;
                        }, new Map())];
            }
        });
    });
}
function computeComplexity(path, options) {
    return __awaiter(this, void 0, void 0, function () {
        var absolutePath, result, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    absolutePath = (0, node_path_1.resolve)(options.directory, path);
                    _a = options.complexityStrategy;
                    switch (_a) {
                        case "sloc": return [3 /*break*/, 1];
                        case "cyclomatic": return [3 /*break*/, 3];
                        case "halstead": return [3 /*break*/, 5];
                    }
                    return [3 /*break*/, 7];
                case 1: return [4 /*yield*/, (0, sloc_1["default"])(absolutePath)];
                case 2:
                    result = _b.sent();
                    return [3 /*break*/, 9];
                case 3: return [4 /*yield*/, (0, cyclomatic_1.calculate)(absolutePath)];
                case 4:
                    result = _b.sent();
                    return [3 /*break*/, 9];
                case 5: return [4 /*yield*/, (0, halstead_1.calculate)(absolutePath)];
                case 6:
                    result = _b.sent();
                    return [3 /*break*/, 9];
                case 7: return [4 /*yield*/, (0, sloc_1["default"])(absolutePath)];
                case 8:
                    result = _b.sent();
                    _b.label = 9;
                case 9:
                    if (!(result instanceof utils_1.UnsupportedExtension)) return [3 /*break*/, 11];
                    return [4 /*yield*/, (0, sloc_1["default"])(absolutePath)];
                case 10:
                    result = _b.sent();
                    _b.label = 11;
                case 11: return [2 /*return*/, result];
            }
        });
    });
}
